image: mcr.microsoft.com/dotnet/sdk:9.0

stages:
  - test
  - publish

before_script:
  - dotnet restore
  - dotnet tool restore

csharpier:
  stage: test
  needs: []
  before_script:
    - dotnet tool restore
  script:
    - dotnet csharpier --check .

test:
  stage: test
  needs: []
  artifacts:
    paths:
      - tests.log
      - Tests/TestResults
      - Tests/Coverage
  script:
    - dotnet test --verbosity n --collect:"XPlat Code Coverage" Tests -d tests.log
    - dotnet reportgenerator "-reports:Tests/TestResults/*/coverage.cobertura.xml" "-targetdir:Tests/Coverage" -reporttypes:Html

publish:
  stage: publish
  only: [tags]
  artifacts:
    when: always
    paths:
      - Money/bin/Debug
  script:
    - sed -i "s/0.0.0-version-placeholder/${CI_COMMIT_TAG}/" Money/Money.csproj
    - dotnet build
    - dotnet nuget push ./Money/nupkg/DKX.Money.${CI_COMMIT_TAG}.nupkg -k ${NUGET_API_KEY} -s https://api.nuget.org/v3/index.json
